#
#   Borland C makefile for SSH2DOS
#

#   Where is your compiler installed?
#Borland C
COMPPATH=c:\borlandc
#COMPPATH=c:\bc4
#Turbo C
#COMPPATH=c:\tc

#   Which compiler do you use?
#Borland C
CC=bcc
#Turbo C
#CC=tcc

# Debug
# DEBUG=-v

# Compiler flags
# remove -DCOLOR to force B&W mode
CFLAGS= -c -ml -O2 -Z -a -d $(DEBUG) -I$(COMPPATH)\include -I.\include -DCOLOR

# Linker flags
LFLAGS= -ml -l-c -lm -L$(COMPPATH)\lib -L.\lib

#################################################################
# In normal cases, no other settings should be changed below!!! #
#################################################################

.c.obj:
	$(CC) $(CFLAGS) $*.c

all: ssh2dos.exe sftpdos.exe

ssh2dos.exe : ssh2dos.obj lib/wattcplg.lib lib/crypto.lib lib/ssh2.lib lib/vt100.lib lib/zlib.lib
	$(CC) $(DEBUG) $(LFLAGS) ssh2dos.obj wattcplg.lib crypto.lib ssh2.lib vt100.lib zlib.lib

sftpdos.exe : sftpdos.obj sftp.obj lib/wattcplg.lib lib/crypto.lib lib/ssh2.lib lib/vt100.lib lib/zlib.lib
	$(CC) $(DEBUG) $(LFLAGS) sftpdos.obj sftp.obj wattcplg.lib crypto.lib ssh2.lib vt100.lib zlib.lib

ssh2dos.obj: ssh2dos.c
sftpdos.obj: sftpdos.c
sftp.obj: sftp.c
negotiat.obj: negotiat.c
transprt.obj: transprt.c
auth.obj: auth.c
channel.obj: channel.c
sshbn.obj: sshbn.c
sshaes.obj: sshaes.c
sshdes.obj: sshdes.c
sshmd5.obj: sshmd5.c
sshsha.obj: sshsha.c
sshsh512.obj: sshsh512.c
int64.obj: int64.c
sshrsa.obj: sshrsa.c
sshdss.obj: sshdss.c
sshpubk.obj: sshpubk.c
vttio.obj: vttio.c
vidio.obj: vidio.c
keyio.obj: keyio.c
keymap.obj: keymap.c
xmalloc.obj: xmalloc.c

lib/crypto.lib: sshbn.obj sshaes.obj sshdes.obj sshmd5.obj sshsha.obj \
		sshsh512.obj int64.obj sshrsa.obj sshdss.obj sshpubk.obj
	tlib lib\crypto.lib -+sshbn.obj -+sshaes.obj -+sshdes.obj -+sshmd5.obj -+sshsha.obj
	tlib lib\crypto.lib -+sshsh512.obj -+int64.obj -+sshrsa.obj -+sshdss.obj -+sshpubk.obj

lib/ssh2.lib: transprt.obj auth.obj channel.obj negotiat.obj xmalloc.obj
	tlib lib\ssh2.lib -+transprt.obj -+auth.obj -+channel.obj -+negotiat.obj -+xmalloc.obj

lib/vt100.lib: vttio.obj vidio.obj keyio.obj keymap.obj
	tlib lib\vt100.lib -+vttio.obj -+vidio.obj -+keyio.obj -+keymap.obj

clean:
	del *.obj
	del *.map
	del lib\vt100.lib
	del lib\crypto.lib
	del lib\ssh2.lib
	del lib\*.bak
	del ssh2dos.exe
	del sftpdos.exe
